﻿from __future__ import division
import es
import popuplib
import langlib
import cfglib
import cmdlib
import playerlib
import gamethread

###############################
# Special Thanks to Tha Pwned #
###############################

config = cfglib.AddonCFG(es.getAddonPath("customvotes") + "/settings.cfg")
config.text("**************************")
config.text("    Addon Settings    ")
config.text("**************************")
config.text("**************************")
config.text("    Votemap Settings    ")
config.text("**************************")
votemapon = config.cvar("votemap",   1, "1 = Enable 0 = Disable")
config.text("**************************")
config.text("    Votekick Settings    ")
config.text("**************************")
votekickon = config.cvar("votekick",   1, "1 = Enable 0 = Disable")
config.text("**************************")
config.text("    Voteban Settings    ")
config.text("**************************")
votebanon = config.cvar("voteban",   1, "1 = Enable 0 = Disable ")
bantime = config.cvar("bantime",   172800, "In Minutes (48 h (2 Days| 48 h * 60 *60)")
config.text("**************************")
config.text("    Votemute Settings    ")
config.text("**************************")
votemuteon = config.cvar("votemute",   1, "1 = Enable 0 = Disable(Please when you have no SM or MA Disable it!)")
config.write()


voteM = {}
voteK = {}
voteB = {}
voteMu = {}
voteMuList = set() 

def selectM(voter, choice, popupid):
	global voteM
	v_steamid = es.getplayersteamid(voter)
	if not voteM.has_key(choice):
		voteM[choice] = []
	percent = voteM[choice]
	Prozent = round(es.getplayercount()/2)+ 1
	for useridx in es.getUseridList():
		if not v_steamid in voteM[choice]:
			voteM[choice].append(v_steamid)
			if len(voteM[choice]) >= round(es.getplayercount()/2)+ 1:
				gamethread.delayed(5, es.server.queuecmd, "changelevel %s" % choice)  
				es.tell(useridx, '#multi', text('mapchanged',{'choice': choice,'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(voter).get('lang')))           
			es.tell(useridx, '#multi', text('mapnotchanged',{'name': es.getplayername(voter),'choice': choice,'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))       
		else:
			es.tell(useridx, '#multi', text('mapnotchanged',{'name': es.getplayername(voter),'choice': choice,'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))       


def selectK(voter, choice, popupid):
	global voteK
	v_steamid = es.getplayersteamid(voter)
	if not voteK.has_key(choice):
		voteK[choice] = []
	percent = voteK[choice]
	Prozent = round(es.getplayercount()/2)+ 1
	for useridx in es.getUseridList():
		if not v_steamid in voteK[choice]:
			voteK[choice].append(v_steamid)
			if len(voteK[choice]) >= round(es.getplayercount()/2)+ 1:
				es.msg('#multi', text('kicked',{'name': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(voter).get('lang')))           
				es.server.queuecmd("kickid %s You have been vote kicked" % choice)
			es.tell(useridx, '#multi', text('notkicked',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))                      
		else:
			es.tell(useridx, '#multi', text('notkicked',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))

def selectB(voter, choice, popupid):
	global voteB
	v_steamid = es.getplayersteamid(voter)
	if not voteB.has_key(choice):
		voteB[choice] = []
	percent = voteB[choice]
	Prozent = round(es.getplayercount()/2)+ 1
	for useridx in es.getUseridList():
		if not v_steamid in voteB[choice]:
			voteB[choice].append(v_steamid)
			if len(voteB[choice]) >= round(es.getplayercount()/2)+ 1:
				es.tell(useridx, '#multi', text('banned',{'name': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(voter).get('lang')))
				es.server.queuecmd('banid bantime %s;writeid' % es.getplayersteamid(choice))
			es.tell(useridx, '#multi', text('notbanned',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))      
		else:
			es.tell(useridx, '#multi', text('notbanned',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))


def selectMute(voter, choice, popupid):
	global voteMu
	v_steamid = es.getplayersteamid(voter)
	if not voteMu.has_key(choice):
		voteMu[choice] = []
	percent = voteMu[choice]
	Prozent = round(es.getplayercount()/2)+ 1
	for useridx in es.getUseridList():
		if not v_steamid in voteMu[choice]:
			voteMu[choice].append(v_steamid)
			if len(voteMu[choice]) >= round(es.getplayercount()/2)+ 1:
				voteMuList.add(choice)
				es.tell(useridx, '#multi', text('muted',{'name': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))
			es.tell(useridx, '#multi', text('notmuted',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))     
		else:
			es.tell(useridx, '#multi', text('notmuted',{'name': es.getplayername(voter),'namech': es.getplayername(choice),'percent': len(percent),'prozent': int(Prozent)},playerlib.getPlayer(useridx).get('lang')))



def ticklistener_mute():
        for allPlayers in es.getUseridList():
                for choice in voteMuList:
                        es.voicechat("nolisten",choice,allPlayers)

def sayfilter_mute(userid, text, teamonly):
        if userid in voteMuList:
                return 0, None, None
        return userid, text, teamonly





def player_disconnect(ev):
	steamid = ev['networkid']
	userid = ev['userid']
	for x in voteM.copy():
  		if steamid in voteM[x]:
    			voteM[x].remove(steamid)
	for x in voteK.copy():
  		if steamid in voteK[x]:
    			voteK[x].remove(steamid)
	for x in voteB.copy():
  		if steamid in voteB[x]:
    			voteB[x].remove(steamid)	
	for x in voteMu.copy():
  		if steamid in voteMu[x]:
    			voteMu[x].remove(steamid)
	for x in voteMuList.copy():
		if userid in voteMuList[x]:
			voteMuList[x].discard(userid)	



def load():
	global text
	config.execute()
	text = langlib.Strings(es.getAddonPath("customvotes") + "/strings.ini")
	if votemapon == 1:
		cmdlib.registerSayCommand('!votemap', voteMa, "Choose a Map")
	if votekickon == 1:
		cmdlib.registerSayCommand('!votekick', voteKi, "Kick a Player")
	if votebanon == 1:
		cmdlib.registerSayCommand('!voteban', voteBa, "Ban a Player")
	if votemuteon == 1:
		es.addons.registerTickListener(ticklistener_mute)
		es.addons.registerSayFilter(sayfilter_mute)
		cmdlib.registerSayCommand('!votemute', voteMut, "Mute a Player")

def unload():
	voteM.clear()
	cmdlib.unregisterSayCommand('!votemap')
	voteK.clear()
	cmdlib.unregisterSayCommand('!votekick')
	voteB.clear()
	cmdlib.unregisterSayCommand('!voteban')
	voteMu.clear()
	cmdlib.unregisterSayCommand('!votemute')
	if votemuteon == 1:
		es.addons.unregisterTickListener(ticklistener_mute)
		es.addons.unregisterSayFilter(sayfilter_mute)
    


def es_map_start(ev):
	if votemapon == 1:
		voteM.clear()
	if votekickon == 1:
		voteK.clear()
	if votebanon == 1:
		voteB.clear()
	if votemuteon == 1:
		voteMu.clear()


def voteMa(userid, args):
	name = 'votemap_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votemapmenu = popuplib.easymenu(name, '_popup_choice', selectM)
	votemapmenu.settitle('Votemap Menu:')
	f = open(es.getString('eventscripts_gamedir') + '/mapcycle.txt')
	m = f.read().split('\n')
	f.close()
	for x in m:
		votemapmenu.addoption(x, x)
	votemapmenu.send(userid)

def voteKi(userid, args):
	name = 'votekick_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votekickmenu = popuplib.easymenu(name, '_popup_choice', selectK)
	votekickmenu.settitle('Votekick Menu:')
	for player in playerlib.getUseridList('#human'):
		votekickmenu.addoption(player, es.getplayername(player))
	votekickmenu.send(userid)

def voteBa(userid, args):
	name = 'voteban_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votebanmenu = popuplib.easymenu(name, '_popup_choice', selectB)
	votebanmenu.settitle('Voteban Menu:')
	for player in playerlib.getUseridList('#human'):
		votebanmenu.addoption(player, es.getplayername(player))
	votebanmenu.send(userid)

def voteMut(userid, args):
	name = 'votemute_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votemutemenu = popuplib.easymenu(name, '_popup_choice', selectMute)
	votemutemenu.settitle('Votemute Menu:')
	for player in playerlib.getUseridList('#human'):
		if not player in voteMuList:
			votemutemenu.addoption(player, es.getplayername(player))
	votemutemenu.send(userid)